// C.Dupaty 09/2010
// test_uOLED.c
// demo gestion afficheur graphique uOLED-128-G1 (SGC)
// les quivalences (#define) des commandes sont dans GSGCdef.h
// le descritif des commande uOLED est dans : GOLDELOX-SGC-COMMANDS-SIS-rev3.pdf
// le description des connexions et utilitaires uOLED sont dans : uOLED-128-G1SGC-DS-rev4.pdf
// La carte uSD a t charg depuis un PC avec 3 images et une vido  partir de l'utilitaire GraphicsComposer.exe
// ce dernier a genere un fichier test.txt qui contient entre autre les adresses de ce objets dans la mmoire uSD
// IMPORTANT !!! le module uOLED est connect  une carte PICDEM2+ SANS l'interface RS232.
//
// Microcontroleur P18F4620 sur horloge interne 8MHz, le module uOLED est connect sur 
// le connecteur DIL 28 broches, 
// 17 : TX (donc RX de uOLED)
// 18 : RX (donc TX de uOLED)
// 19 : 0v
// 20 : 5v
// 21 : Reset uOLED
//
// Ce programme peut tre utilise sans afficheur LCD ni PICDEM2+ (retirer alors tous les
// appels aux fonctions de gestion du LCD)

#include <p18f4620.h>
#include <stdio.h>  // pour fprintf
#include "xlcd.h"	// lib cree avec MAESTRO pour l'afficheur LCD (ici PICDEM2+)
#include "GSGCdef.h"	// commandes uOLED

#define S2 PORTAbits.RA4		// bouton S2 sur PICDEM2+
#define reset PORTBbits.RB0
#define TRISreset TRISBbits.TRISB0

#define SPOCK 	0x014160	// adresses des images dans la uSD (voir fichier test.txt)
#define GASTON 	0x0140E0
#define OMER 	0x014120
#define BINGO	0x001000	// adress de la video

unsigned char chaine1[]="Test uOLED-128-G1 (SGC)";

void putsci(unsigned char c)
{
	while(!TXSTAbits.TRMT);
    TXREG=c;                           /* envoie un caractre */
    while(!PIR1bits.TXIF);
}

char data_recue(void)			// reception d'unedonnee
{
	if (PIR1bits.RCIF)		/* char recu en reception*/
	{	
		PIR1bits.RCIF=0;	// efface drapeau
		return (1);	// indique qu'un nouveau caractre est dans RCREG
	}	
	else return (0);		// pas de nouveau caractre reu
}

char ack(void)
{
		while (!data_recue());
		return(RCREG);
}

void rectangle(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2,unsigned int color)
{
	putsci(GSGC_RECTANGLE);
	putsci(x1);
	putsci(y1);	
	putsci(x2);
	putsci(y2);
	putsci(color>>8);
	putsci(color&0x00FF);
}

void cercle(unsigned char x,unsigned char y,unsigned char radius,unsigned int color)
{
	putsci(GSGC_CIRCLE);
	putsci(x);
	putsci(y);	
	putsci(radius);
	putsci(color>>8);
	putsci(color&0x00FF);
}

void afftexte_graphic(char x, char y, char font,int color , char w, char h, char * mess)
{
	putsci(GSGC_STRINGGFX);
	putsci(x);
	putsci(y);
	putsci(font);
	putsci(color>>8);
	putsci(color&0x00FF);
	putsci(w);
	putsci(h);
	fprintf(_H_USART,"texte NON formate %s",mess);
	putsci(0);
}

void afftexte_text(char x,char y,char font,int color,char* mess)
{
	putsci(GSGC_STRINGTXT);
	putsci(x);
	putsci(y);
	putsci(font);
	putsci(color>>8);
	putsci(color&0x00FF);
	fprintf(_H_USART,"texte formate : %s",mess);
	putsci(0);
}

void affiche_image(char x, char y, char w, char h, char color, unsigned long ad)
{
	putsci('@');
	putsci(GSGC_MCIMAGE);
	putsci(x);
	putsci(y);
	putsci(w);
	putsci(h);
	putsci(color);
	putsci(ad>>16);
	putsci((ad>>8)&0x0000FF);
	putsci(ad&0x0000FF);
}

void affiche_video(char x, char y, char w, char h, char color, char delay, int frames,unsigned long ad)
{
	putsci('@');
	putsci(GSGC_MCVIDEO);
	putsci(x);
	putsci(y);
	putsci(w);
	putsci(h);
	putsci(color);
	putsci(delay);
	putsci(frames>>8);
	putsci(frames&0x00FF);
	putsci(ad>>16);
	putsci((ad>>8)&0x0000FF);
	putsci(ad&0x0000FF);
}

void efface(void)
{unsigned int i;
		putsci(GSGC_CLS);		// efface ecran	
		for(i=0;i<20000;i++);
}

  // dirige user_putc vers l'afficheur LCD du PD2+
int _user_putc (char c)
{
	XLCDPut(c);
}


void main(void)
{
unsigned long i;

	init_horloge_interne();
	TRISCbits.TRISC7 = 1;  // RX - Set Recieve pin for tristate
	TRISCbits.TRISC6 = 0;  // TX - Set as Output
	TRISreset = 0; 	// RESET uOLED en sortie

	SPBRGH= 0x06;						// SPBRG est compose de SPBRGH et SPBRG
	SPBRG = 51; 	           			/* configure la vitesse (BAUD) 9600 N 8 1*/
    TXSTA = 0b00100000; 	                  
    RCSTA = 0b10010000;			 			/* active l'USART*/
	BAUDCONbits.BRG16=0;	// SPBRGH = 0 pour 9600 (ignore SPBRGH et 1 pour 1200
	TXSTAbits.BRGH=0;		// High Speed
	
	XLCDInit();
	XLCDL1home();					//ligne 0 de l'afficheur
	fprintf(_H_USER, "TEST uOLED       " );	// vers LCD
	reset=1;						// Reset module uOLED
	reset=0;
	Nop(); Nop(); Nop(); Nop();
	reset=1;
	do
	{
		putsci(GSGC_AUTOBAUD);		// test connexion uOLED
		while (!data_recue());
	}
	while (RCREG !=ACK);			// si ACK=1 les communications sont tablies
	while(1)
	{	
		efface();
		XLCDL2home();
		fprintf(_H_USER, "OK ! pressez S2 ");
		while(S2);
		while(!S2);

		putsci(GSGC_VERSION);	// affiche infos uOLED
		putsci(0x01);
		XLCDL2home();
		fprintf(_H_USER, "S2: infos        ");
		while(S2);
		while(!S2);

		efface();
		rectangle(10,10,100,80,RED); // affiche un rectangle rouge plein
		XLCDL2home();
		fprintf(_H_USER, "S2: rectangle    ");
		while(S2);
		while(!S2);

		cercle(50,90,30,BLUE); // affiche un cercle bleu plein
		XLCDL2home();
		fprintf(_H_USER, "S2: cercle    ");
		while(S2);
		while(!S2);

		efface();
		afftexte_text(2,2,FONT3,RED,chaine1); // affiche un texte formate 
		XLCDL2home();
		fprintf(_H_USER, "texte FORMATE    ");
		while(S2);
		while(!S2);

		efface();
		afftexte_graphic(10,12,FONT2,GREEN,2,2,chaine1); // affiche un texte graphique
		XLCDL2home();
		fprintf(_H_USER, "texte GRAPHIC ");
		while(S2);
		while(!S2);

		efface();
		affiche_image(0,0,0x80,0x80,COLOR16,SPOCK); // SPOCK
		XLCDL2home();
		fprintf(_H_USER, "S2: Spock        ");
		while(S2);
		while(!S2);

		affiche_image(0,0,0x80,0x80,COLOR16,GASTON); // GASTON
		XLCDL2home();
		fprintf(_H_USER, "S2: Gaston        ");
		while(S2);
		while(!S2);

		affiche_image(0,0,0x80,0x80,COLOR16,OMER); // OMER
		XLCDL2home();
		fprintf(_H_USER, "S2: Omer          ");
		while(S2);
		while(!S2);
		//
		efface();
		XLCDL2home();
		fprintf(_H_USER, "Video BINGO     ");	// une video
		affiche_video(0,0x10,0x80,0x60,COLOR16,0x27,0x065A,BINGO);
		while(ack()!=ACK);
		XLCDL2home();
		fprintf(_H_USER, "recommencer : S2");	// une video
		while(S2);
		while(!S2);
	}
}
	
	